
function nothing(...) end
function TODO(...) print("TODO...") end


local fakelove = {}
-- backup the original require function
fakelove.require = require

local print = print
local module = module

fakelove.internaldata = {}
function getInternalDataTable()
        return fakelove.internaldata
end

local lovemoduleload = function(modname, love)
	if love == nil then
		error("love table not exists??")
	end
	if not love[modname] then
		love[modname] = {}
		local origrequire = fakelove.require
		origrequire("love."..modname)
		module("love."..modname)
	end
	return love[modname]
end

-- patch the require function
require = function(modname)
	print("require called for", modname)
	if modname == "conf.lua" or modname == "main.lua" then
		local ok, result = pcall(dofile, modname)
		return ok
	end

	if modname:find("^love\.") then
		local submodname = modname:gsub("^love\.(.*)$", "%1")
		return lovemoduleload(submodname, love)
	end

	local ok, result = pcall(dofile, modname..".lua")
	if ok then
		return result
	end
	local origrequire = fakelove.require
	return origrequire(modname)
end

dofile("embeded/boot.lua")

